package	jp.co.sds_corp.fixconnect.message.validator;

import java.util.HashMap;

import jp.co.sds_corp.fixconnect.message.FIXMessage;
import jp.co.sds_corp.fixconnect.message.Tag;
import jp.co.sds_corp.util.config.IConfiguration;

public class ValidatorFactory
{
	HashMap<String,IValidator> mapVal = new HashMap<String,IValidator>();
	protected ValidatorFactory() {
	}

	public void init( IConfiguration config ) throws Exception {
		String file = config.getAttributes().get( "file" );
	}

	public void validate( FIXMessage msg ) throws Exception {
		String type = msg.getValue( Tag.MsgType );
		IValidator val = mapVal.get( type );
		val.validate( msg );
	}

	public IValidator getValidator( FIXMessage msg ) throws Exception {
		return null;
	}

/*
	protected void readDictionary( String file ) throws Exception {
		DOMConfiguration dict = new DOMConfiguration( file );
		Iterator<IConfiguration> itr = dict.getChilds( "tag" );
		while ( itr.hasNext()) {
			IConfiguration c = itr.next();
			String var;
			Tag tag = new Tag();
			var = c.getAttributes().get( "id" );
			tag.setTagId( Integer.valueOf( var ));
			tag.setName( c.getAttributes().get( "name" ));
			var = c.getAttributes().get( "type", "" );
			if ( var.equals( "HEAD" )) {
				tag.setPosition( Tag.Position.HEADER );
			} else
			if ( var.equals( "BODY" )) {
				tag.setPosition( Tag.Position.BODY );
			} else
			if ( var.equals( "TRAILER" )) {
				tag.setPosition( Tag.Position.TRAILER );
			}
			var = c.getAttributes().get( "required", "false" );
			if ( var.equals( "true" )) {
				tag.setRequired( true );
			}
			addTag( tag );
		}
	}
*/

}
