package	jp.co.sds_corp.fixconnect.logger;

import jp.co.sds_corp.fixconnect.message.FIXMessage;
import jp.co.sds_corp.util.config.IConfigurable;

public interface IMessageLogger extends IConfigurable
{
	public enum Direction {
		NONE, SEND, RECV, BOTH
	}

	public void log( Direction dir, FIXMessage msg ) throws Exception;
	public Direction getDirection();
}
