package	jp.co.sds_corp.fixconnect.logger;

import jp.co.sds_corp.fixconnect.message.FIXMessage;
import jp.co.sds_corp.util.common.CmnLog;
import jp.co.sds_corp.util.config.IConfiguration;

public class SimpleLogger extends AbstractMessageLogger
{
	public void init( IConfiguration config ) throws Exception {
		super.init( config );
	}

	public void log( Direction direction, FIXMessage msg ) throws Exception {
		String log = direction + " " + msg.toString();
		if ( isDump()) {
			log += "\n" + dump( msg );
		}
		CmnLog.debug( this, log );
	}

}
